1597: [Usaco2008 Mar]土地购买
Time Limit: 10 Sec Memory Limit: 162 MBSubmit: 2931 Solved: 1091
[Submit][Status][Discuss]
Description
农夫John准备扩大他的农场,他正在考虑N (1 <= N <= 50,000) 块长方形的土地. 每块土地的长宽满足(1 <= 宽 <= 1,000,000; 1 <= 长 <= 1,000,000). 每块土地的价格是它的面积,但FJ可以同时购买多快土地. 这些土地的价格是它们最大的长乘以它们最大的宽, 但是土地的长宽不能交换. 如果FJ买一块3x5的地和一块5x3的地,则他需要付5x5=25. FJ希望买下所有的土地,但是他发现分组来买这些土地可以节省经费. 他需要你帮助他找到最小的经费.
Input
* 第1行: 一个数: N
* 第2..N+1行: 第i+1行包含两个数,分别为第i块土地的长和宽
Output
* 第一行: 最小的可行费用.
Sample Input
4
100 1
15 15
20 5
1 100
输入解释:
共有4块土地.
100 1
15 15
20 5
1 100
输入解释:
共有4块土地.
Sample Output
500
HINT
FJ分3组买这些土地: 第一组:100x1, 第二组1x100, 第三组20x5 和 15x15 plot. 每组的价格分别为100,100,300, 总共500.
Source
Solution
DP没什么好说的,至于数据范围,铁定得优化到$O(n/nlogn)$,那么考虑斜率优化
题目大意就是划分多组,每组最长*每组最宽为每组的价值,要求价值最小
很容易发现,如果一块土地,他的长和宽都小于等于他所在组的最长长和最长宽,那么这块土地是没有存在的必要的
那么可以考虑对原始数据进行排序,并用 单调栈 去维护一下长宽,达到目的
这样容易得出转移 $dp[i]=min(dp[j]+y[j+1]*x[i])$
那么进行斜率优化得到$(dp[j-1]-dp[k-1])/(y[j]-y[k])>-x[i]$
Code
#include<iostream> #include<cstdio> #include<algorithm> #include<cstring> #include<cmath> using namespace std; int read() { int x=0;char ch=getchar(); while(ch<'0'||ch>'9')ch=getchar(); while(ch>='0'&&ch<='9'){x=x*10+ch-'0';ch=getchar();} return x; } #define maxn 50010 int n,top,que[maxn],l,r; long long stackx[maxn],stacky[maxn],dp[maxn]; struct Fieldnode { int a,b; bool operator < (const Fieldnode & A) const { if (a==A.a) return b<A.b; return a<A.a; } }fie[maxn]; double slope(int i,int j) {return (dp[j]-dp[i])/(stacky[i+1]-stacky[j+1]);} int main() { n=read(); for (int i=1; i<=n; i++)fie[i].a=read(),fie[i].b=read(); sort(fie+1,fie+n+1); for (int i=1; i<=n; i++) { while (top && fie[i].b>=stacky[top]) top--; top++; stackx[top]=fie[i].a; stacky[top]=fie[i].b; } for (int tmp,i=1; i<=top; i++) { while (l<r && slope(que[l],que[l+1])<stackx[i]) l++; tmp=que[l]; dp[i]=dp[tmp]+stackx[i]*stacky[tmp+1]; while (l<r && slope(que[r],i)<slope(que[r-1],que[r])) r--; que[++r]=i; } printf("%lld ",dp[top]); return 0; }
一道奶牛题做成这样也是醉了...